Kerbal Space Program - Bug #23182

Hinges consume electricity even when they are not moving.
07/14/2019 03:15 PM - dok_377

Status: Closed Start date: 07/14/2019
Severity: Low % Done: 100%
Assignee:

Category: Parts

Target version: 1.8.0

Version: 1.7.3 Language: English (US)
Platform: OSX, Windows Mod Related: No
Expansion: Breaking Ground, Core Game

Description

Reproduction steps:

1. Take a couple of hinges and attach them to your craft (the standard hinges, alligators are fine by the look of it)
2. Set one of them to either 90 degrees or -90 degrees

3. Launch craft and look at the electricity consumption

The effect of that bug appears if the hinge is set to 90 or -90 in the editor, it will either constantly consume electricity, or it will briefly
flash the consumption value as shown in the video below.

4. In flight set the other hinge (that was left at 0 in the editor) at 90 or -90 and it will do the same thing as above.
It seems like this happens only if the hinge is set to the maximum or the minimum angle (90 and -90) set by the default for that part. If
you limit the deploy angle and set the maximum or minimum again (let's say it was limited to -89 and 89, for example), then the part

is fine and do not consume any electricity when it's not moving.

Video: https://youtu.be/m_NchékvUcY

History

#1 - 07/14/2019 06:38 PM - Kirk
See also #23175.

#2 - 07/15/2019 04:04 AM - Dunbaratu

I've noticed that it feels like the robotic servo parts draw the same electricity if they're moving at all, regardless of how much they're moving. As long
as they're moving at all they cost the same power drain, whether in the middle of their traversal where they're moving at their fastest, or toward the
end of their traversal as they slow down to ease into position.

Pure guesswork here -> Perhaps what's happening here is that if their final destination is at the extreme ends of the scale, then as they approach
their final target destination, they approach it in a sort of Zeno's Paradox never quite getting there. So instead of settling in on the 90 degree position
and stopping, maybe they're at position 89.9, then 89.99, then 89,999, then 89.9999, etc, and because the power draw is behaving in a sort of
Boolean fashion, as long as they're still moving, even if it's 0.0001 degrees per second, the game still drains power fully?

#3 - 07/15/2019 02:00 PM - dok_377

Dunbaratu wrote:

I've noticed that it feels like the robotic servo parts draw the same electricity if they're moving at all, regardless of how much they're moving. As
long as they're moving at all they cost the same power drain, whether in the middle of their traversal where they're moving at their fastest, or
toward the end of their traversal as they slow down to ease into position.

Pure guesswork here -> Perhaps what's happening here is that if their final destination is at the extreme ends of the scale, then as they
approach their final target destination, they approach it in a sort of Zeno's Paradox never quite getting there. So instead of settling in on the 90
degree position and stopping, maybe they're at position 89.9, then 89.99, then 89,999, then 89.9999, etc, and because the power draw is
behaving in a sort of Boolean fashion, as long as they're still moving, even if it's 0.0001 degrees per second, the game still drains power fully?

That's an interesting guess. Yeah, | also noticed that they consume the same amount of electricity regardless of their speed. You can even see that in
the video | posted.
https://youtu.be/m_Nch6kvUcY
https://bugs.kerbalspaceprogram.com/issues/23175

#4 - 07/21/2019 10:03 AM - Dunbaratu

Dunbaratu wrote:

Pure guesswork here -> Perhaps what's happening here is that if their final destination is at the extreme ends of the scale, then as they
approach their final target destination, they approach it in a sort of Zeno's Paradox never quite getting there.

| want to add another observation for SQUAD devs to see that makes me believe this is indeed the problem:
Just now | was trying to program the KAL1000 to activate the "Engage Servo Lock" action for a hinge servo after the KAL1000 has moved it. It didn't
lock it. | tried the steps manually and discovered this problem:

- If | set the hinge's Target Angle to 90 degrees, it's max allowed value, | can't click on the "Locked" button on the PAW, even though the display
SHOWS that it's value has reached "90.0".
- But if | then set the hinge's Target Angle to 89 degrees, just shy of its max value, then the "Locked" button on the PAW starts working.

The "Locked" button is normally disallowed if the part is still in motion.

So now this is 2 different effects, power drain and disallowing the "Locked" button, both of which are normally connected to the game thinking "this
Robotic servo is in motion", that don't work right when the part is told to seek its max setting. Thus, even more than before, | suspect the game is still
registering a tiny bit of motion and never fully reaching that endpoint value.

#5 - 08/31/2019 10:36 PM - traisjames

- Status changed from New to Confirmed
- % Done changed from 0 to 10

- Platform OSX added

- Platform deleted (Windows)

- Expansion Making History added

#6 - 08/31/2019 10:37 PM - traisjames
- Platform Windows added
- Expansion deleted (Making History)

#7 - 10/17/2019 08:54 PM - victorr
- Status changed from Confirmed to Ready to Test
- Target version set to 1.8.0

- % Done changed from 10 to 80

We've made some changes in the latest version and would like some feedback on this issue. Thanks.

#8 - 10/18/2019 12:39 AM - dok_377
- Status changed from Ready to Test to Resolved
- % Done changed from 80 to 100

| checked it and the recent changes do appear to fix this issue. Thanks.

#9 - 10/18/2019 11:19 AM - jclovis3

Also, you might want to allow time after movement for the parts to settle in case of bounce back before you try to lock them. | like to span 15 seconds,
get the part moving and wait about 13 seconds or so before | try to lock it, then | disengage the motor (full cycle is engage, unlock, move, wait, lock,
engage). | also set the movement rate rather slow too so it don't bounce so much when it reaches the end. In space and low gravity planets (Mun
included) this seems ok. | find most parts too be too weak to function properly under Kerbin gravity. Perhaps the design stage should include a gravity
simulator when building it.

#10 - 10/18/2019 04:09 PM - chris.fulton

- Status changed from Resolved to Closed
